; 
    include \masm32\include\masm32rt.inc
    include \masm32\include\urlmon.inc
    includelib \masm32\lib\urlmon.lib
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    start_new_thread PROTO :DWORD, :DWORD
    new_thread       PROTO :DWORD

    tblock STRUCT
      strn1 db 260 dup (?)
      strn2 db 260 dup (?)
      reserved dd ?             ; this is used internally
    tblock ENDS

    .code

start:
   
; 

    call main
    print "Downloading 5 test zip files, press any key when 5 files are downloaded",13,10
    call wait_key
    print chr$(13,10)

    exit

; 

main proc

    LOCAL tblk:tblock

    cst ADDR tblk.strn1, "http://www.masm32.com/website/files/nre.zip"
    cst ADDR tblk.strn2, "nre.zip"
    invoke start_new_thread,OFFSET new_thread, ADDR tblk

    cst ADDR tblk.strn1, "http://www.masm32.com/website/files/owde.zip"
    cst ADDR tblk.strn2, "owde.zip"
    invoke start_new_thread,OFFSET new_thread, ADDR tblk

    cst ADDR tblk.strn1, "http://www.masm32.com/website/files/pfe101i.zip"
    cst ADDR tblk.strn2, "pfe101i.zip"
    invoke start_new_thread,OFFSET new_thread, ADDR tblk

    cst ADDR tblk.strn1, "http://www.masm32.com/website/files/random.zip"
    cst ADDR tblk.strn2, "random.zip"
    invoke start_new_thread,OFFSET new_thread, ADDR tblk

    cst ADDR tblk.strn1, "http://www.masm32.com/website/files/td_win32asm_all.zip"
    cst ADDR tblk.strn2, "td_win32asm_all.zip"
    invoke start_new_thread,OFFSET new_thread, ADDR tblk

    ret

main endp

; 

start_new_thread proc pthread:DWORD, pstruct:DWORD

    LOCAL tID       :DWORD

    push esi

  ; -----------------------------------------
  ; load the "reserved" flag address into ESI
  ; -----------------------------------------
    mov eax, pstruct
    lea esi, (tblock PTR [eax]).reserved

  ; ----------------------------
  ; set the "reserved" flag to 1
  ; ----------------------------
    mov DWORD PTR [esi], 1

    invoke CreateThread,0,0,pthread,pstruct,0,ADDR tID

  ; ------------------------------------
  ; run a yielding loop until new thread
  ; sets "reserved" flag back to zero
  ; ------------------------------------
  spinlock:
    invoke SleepEx,1,0
    cmp DWORD PTR [esi], 0
    jne spinlock

    pop esi

    mov eax, tID
    ret

start_new_thread endp

; 

new_thread proc pstruct:DWORD

    LOCAL pst1  :DWORD
    LOCAL pst2  :DWORD
    LOCAL buffer1[260]:BYTE
    LOCAL buffer2[260]:BYTE

    mov pst1, ptr$(buffer1)
    mov pst2, ptr$(buffer2)

    push esi
    push edi

    mov edi, pstruct
    lea esi, (tblock PTR [edi]).reserved
    lea ecx, (tblock PTR [edi]).strn1
    cst pst1, ecx                           ; copy string at address in ECX
                                            ; to local buffer1 at address pst1
    lea ecx, (tblock PTR [edi]).strn2
    cst pst2, ecx                           ; copy string at address in ECX
                                            ; to local buffer2 at address pst2
  ; --------------------------------------
  ; reset the "reserved" flag back to zero
  ; --------------------------------------
    mov DWORD PTR [esi], 0

    pop edi
    pop esi

  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ; perform normal thread operations once the arguments have been written.
  ; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

    print "Downloading "
    print pst2,13,10

    fn URLDownloadToFile,0,pst1,pst2,0,0

    print pst2," Done",13,10

    ret

new_thread endp

; 

end start
